# -*- coding: utf-8 -*-
##############################################################################
#
#	OpenERP, Open Source Management Solution
#	Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU Affero General Public License as
#	published by the Free Software Foundation, either version 3 of the
#	License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU Affero General Public License for more details.
#
#	You should have received a copy of the GNU Affero General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields, osv
from datetime import datetime , timedelta
import sys
from zklib import zklib
import time
from zklib import zkconst

#-------------------------------------------------------------------- import sys
#--------------------------------------------------------------------- import os
#---------------------------------- sys.path.insert(1,os.path.abspath("./pyzk"))
#------------------------------------------------------ from zk import ZK, const

from datetime import date
from datetime import timedelta
from datetime import datetime
from openerp.tools.translate import _
from openerp.tools import DEFAULT_SERVER_DATE_FORMAT, DEFAULT_SERVER_DATETIME_FORMAT
from operator import itemgetter
from mx.DateTime.DateTime import MinDateTime, MaxDateTime
DATETIME_FORMAT = "%Y-%m-%d %H:%M:%S"
DATE_FORMAT = "%Y-%m-%d"
TIME_FORMAT = "%H:%M:%S"
	

class biometric_machine(osv.Model):
	_name= 'biometric.machine'
	_columns = {
		'start_date':fields.date('Start date',required=True),
		'name' : fields.char("Machine IP"),
		'dev_name':fields.char('Device name'),
		'ref_name' : fields.char("Location"),
		'port': fields.integer("Port Number"),
		'address_id' : fields.many2one("res.partner",'Working Address'),
		'state': fields.selection([('draft','Draft'),('done','Done')],'State'),
		'company_id': fields.many2one("res.company","Company Name"),
		'clear_log': fields.boolean("Clear Log"),
		'info_id':fields.many2one('biometric.machine.info','Biometric machine info'),
	}
	_defaults = {
				'company_id': lambda self,cr,uid,c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
				 }
	
	def action_connect(self, cr, uid, ids, context=None):
		machine_ip = self.browse(cr,uid,ids).name
		port = self.browse(cr,uid,ids).port
		zk = zklib.ZKLib(machine_ip, int(port))
		res = zk.connect()
		if res == True:
			raise osv.except_osv(_(u"Мессеж"), _(u"Холболт амжилттай боллоо."))
			return True
		else:
			raise osv.except_osv(_(u"Мессеж"), _(u"Холболт амжилтгүй боллоо !."))
		return False


	def clear_data(self, cr, uid, ids, context=None):
		obj = self.browse(cr, uid, ids)
		machine_ip = self.browse(cr,uid,ids).name
		port = self.browse(cr,uid,ids).port
		zk = zklib.ZKLib(machine_ip, int(port))
		res = zk.connect()
		zk.enableDevice()
		clear = zk.clearAttendance()
		if clear==True:
	    		raise osv.except_osv(_(u"Мессеж"), _(u"Ирц амжилттай устгалаа."))
		return True
	
	
	def download_attendance(self, cr, uid, ids, context=None):
	   	hr_date = self.browse(cr, uid, ids)[0]
	   	machine_ip = self.browse(cr,uid,ids).name
	   	print 'machine_ipmachine_ip', machine_ip
	        port = self.browse(cr,uid,ids).port
	        print 'portportport', port
	        zk = zklib.ZKLib(machine_ip, int(port))
	        print 'zkzkzkzkzk', zk
	        res = zk.connect()
	        print 'resresres', res
	        if res == True:
			zk.enableDevice()
			attendance = zk.getAttendance()
			print 'attendanceattendanceattendance', attendance
			user = zk.getUser()
			hr_attendance =  self.pool.get("hr.attendance")
			hr_employee = self.pool.get("hr.employee")
			hr_contract_obj = self.pool.get('hr.contract')
			state = 'sign_in'
			list_time = []
			i=0#shineer vvssen
			j=0#vvssen bgaa
			k=0#niit
			n=0#tataj bui ognoonoos omnoh
			p=0
			if ( attendance ):
				print 'aaaaaaaattttttttttttttttt', ( attendance )
				for lattendance in sorted(attendance):
					p=p+1
					print 'xxxxxxxxxxxxxx',p
					print 'wwwwwwwwwwwwwwwwwwwwwwwww', lattendance
					if str(lattendance[2].date()) >= hr_date.start_date:							
						time_att = str(lattendance[2].date()) + ' ' +str(lattendance[2].time())
						atten_time1 = datetime.strptime(str(time_att), '%Y-%m-%d %H:%M:%S')
						atten_time = atten_time1 - timedelta(hours=hr_date.info_id.diff_time)
						atten_time = datetime.strftime(atten_time,'%Y-%m-%d %H:%M:%S')
						atten_time1 = datetime.strftime(atten_time1,'%Y-%m-%d %H:%M:%S')
						in_time = datetime.strptime(atten_time1,'%Y-%m-%d %H:%M:%S').time()
	
				
						employee_id = hr_employee.search(cr, uid, [('employee_code','=',lattendance[0])])
						if employee_id !=[]:
							if lattendance[1] == 0:
								state = 'sign_in'								
							else:
								state = 'sign_out'
							
							atten_ids = hr_attendance.search(cr,uid,[('employee_id','=',employee_id[0]),('name','=',atten_time)],limit=1)
							print 'yyyyyyyyyy', atten_ids
							if atten_ids == []:
								atten_id = hr_attendance.create(cr,uid,{'name':atten_time,'employee_id':employee_id[0],'action':'action'})
								i=i+1
								print 'uuuuuuuuuuuuuu', i
							else:
								j=j+1
								print 'nnnnnnnnnnnnn', j
					else:
						print 'qqqqqqqqqqqqqqqqqqq'
						n=n+1
				
				k=i+j
				print 'Шинээр үүссэн ирцийн тоо', i
				print 'Үүссэн байсан', j
				print 'Ирцийн төхөөрөмжөөс шалгасан нийт огнооноос хойших ирцийн тоо', k
				print 'Ирцийн төхөөрөмжөөс шалгасан нийт огнооноос өмнөх ирцийн тоо', n
				print 'Ирцийн төхөөрөмж дэхь нийт ирцийн тоо', p
				zk.enableDevice()
				zk.disconnect()
				return True
			else:
			        raise osv.except_osv(_(u'Анхааруулга !'),_(u"Төхөөрөмжтэй холбогдсонгүй та сүлжээний холболтоо шалгана уу"))
	        

	
class biometric_machine_info(osv.osv):
	_name = 'biometric.machine.info'
	
	_columns = {
				'name':fields.char('Machine info'),
				'company_id':fields.many2one('res.company','Company'),
				'machine_line_id':fields.one2many('biometric.machine','info_id','Biometric machine'),
				'diff_time':fields.integer('Time different'),
				'compute_date':fields.date('Compute date'),
				'clear_log': fields.boolean("Clear Log"),
			}
	
	def onchange_compute_date(self, cr, uid, ids, compute_date, context=None):
		obj = self.browse(cr, uid, ids)
		res = {}
		if compute_date != False:
			for line in obj.machine_line_id:
				line.write({'start_date':compute_date})
        	return True
	
	def onchange_clear_log(self, cr, uid, ids, clear_log, context=None):
		obj = self.browse(cr, uid, ids)
		res = {}
		for line in obj.machine_line_id:
			line.write({'clear_log':clear_log})
		return True
	
	def action_auto(self, cr, uid, ids, context=None):
		obj = self.browse(cr, uid, ids)
		if obj.machine_line_id:
			for line in obj.machine_line_id:
				self.pool.get('biometric.machine').download_attendance(cr, uid, line.id)
		return True

	def action_clear_data(self,cr, uid, ids, context=None):
		obj = self.browse(cr, uid, ids)
		if obj.machine_line_id:
			for line in obj.machine_line_id:
				self.pool.get('biometric.machine').clear_data(cr, uid, line.id)
		return True

	def compute_attendances(self, cr, uid, ids, context=None):
		data = self.browse(cr, uid, ids)[0]
		self.context = context
		#ctx = self.context.copy()
		pre_date = data.compute_date
		now_date = datetime.now()
		atten3_time23 =''
		days = []
		idate = datetime.strptime( data.compute_date,DATE_FORMAT)
		while idate <= datetime.strptime(str(now_date.date()),DATE_FORMAT):
			print 'Шалгах өдөр: ', idate
			print '---------------------------'
			days.append(idate)
			idate += timedelta(days = 1)
		obj = self.browse(cr, uid, ids)
		att_obj = self.pool.get('hr.attendance')
		emp_obj = self.pool.get('hr.employee')
		emp_id = emp_obj.search(cr, uid, [('active','=',True)])
		atts = []
		atts_in =[]
		atts_out =[]
		#=======================================================================
		# real_comp_datetime = datetime.strptime(data.compute_date, DATE_FORMAT) - timedelta(days=1)
		# print 'xxxxxxxxxxxxxxxx', data.compute_date, '-----', real_comp_datetime
		# real_comp_date = real_comp_datetime.strftime(DATE_FORMAT)
		# print 'aaasasasasasas', real_comp_date
		#=======================================================================
		for actions in att_obj.browse(cr, uid, att_obj.search(cr, uid, [('action','!=','action'),('name','>=',data.compute_date)])):
			print 'Үйлдэл : Ирц ID, Ирц огноо',actions.id, actions.name
			actions_id1 = att_obj.browse(cr,uid,actions.id)
			att_obj.write(cr,uid,actions_id1.id,{'action':'action'})
 		for atid in days:
 			print 'days', atid
 			for line in emp_obj.browse(cr, uid, emp_id):
 				atten_time23 = (datetime.combine(atid, datetime.min.time()))
				signin0 = atten_time23.replace(hour=0, minute=00, second=01)
				signin1 = datetime.strptime(str(signin0), '%Y-%m-%d %H:%M:%S') - timedelta(hours=8)
				atten_time33 = (datetime.combine(atid, datetime.min.time()))
				signout0 = atten_time33.replace(hour=23, minute=59, second=59)
				signout1 = datetime.strptime(str(signout0), '%Y-%m-%d %H:%M:%S') - timedelta(hours=8)
				for sign_in in att_obj.browse(cr, uid, att_obj.search(cr, uid, [('employee_id','=',line.id),('name','>=',str(signin1)),('name','<=',str(signout1))],order='name asc',limit=1)):
		 			print 'Орсон : Ирц ID, Ирц огноо',sign_in.id, sign_in.name, sign_in.employee_id.name
					sign_in_id = att_obj.browse(cr,uid,sign_in.id)
					att_obj.write(cr,uid,sign_in.id,{'action':'sign_in'})
					atts_in.append(sign_in.id)
			 	for sign_out in att_obj.browse(cr, uid, att_obj.search(cr, uid, [('employee_id','=',line.id),('name','>=',str(signin1)),('name','<=',str(signout1))],order='name desc',limit=1)):
		 			print 'Гарсан : Ирц ID, Ирц огноо',sign_out.id, sign_out.name
					sign_out_id = att_obj.browse(cr,uid,sign_out.id)
					if sign_in.id == sign_out.id:
						pass
					else:
						att_obj.write(cr,uid,sign_out_id.id,{'action':'sign_out'})
					atts_out.append(sign_out.id)
		return True


