# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2014 iERP Consulting (<http://www.ierp.mn>)
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

{
    "name" : "IERP - Account",
    "version" : "1.0",
    "description": """
        Монголын санхүүгийн модуль.
    * Шаардлага -> Account.
    * Монголын санхүүгий модуль нь монголын санхүү, гүйлгээнд шаардлагатай Балансын горим, Мөнгөн гүйлгээ, 
    Төлбөрийн даалгавар, Ханш тэгшитгэлийг хийнэ.
    """,
    "depends" : [
                 "analytic",
                 "account_asset",
                 "account_voucher",
                 "account",
                 "hr",
                 "ierp_sale",
                 #"l10n_mn_account_report",
                 #"l10n_mn_account_journal_report",
    ],
    'external_dependencies': {

        'python' : ['num2words'],

    },
    "demo_xml" : [],
    "update_xml" : [
                    'wizard/account_hoaot_invoice_view.xml',
                    'wizard/account_period_closed_view.xml',
                    'wizard/account_asset_change_duration_view.xml',
                    'wizard/account_currency_equalization_view.xml',
                    'wizard/asset_capital_view.xml',
                    'wizard/compute_asset_view.xml',
                    'wizard/writeoff_view.xml',
                    #'wizard/receivables_detail_register_view.xml',
                    #'wizard/payable_detail_register_view.xml',
                    #'wizard/account_cashflow_statement_report_view.xml',
                    #'wizard/asset_purchase_view.xml',
                    #"account_analytic_account_inherit_view.xml",
                    "currency_eqalization_config_view.xml",
                    'account_inherit_view.xml',
                    #'account_tax_inherit_view.xml',
                    'account_asset_inherit_view.xml',
                    'account_bank_inherit_view.xml',
                    'data/account_cash_move_type_data.xml',
                    'account_invoice_inherit_view.xml',
                    'account_integrate_view.xml',
                    'menu_view.xml',
                    #'report.xml',
                    'report/account_bank_statement_excel_view.xml',
                    'report/account_banks_statement_order_view.xml',
                   ],
    "auto_install": False,
    "installable": True,
}