import time

from openerp.osv import fields, osv

class contract_history_schedule(osv.osv):
    _name = 'contract.history.schedule'
    _description = "Contract History Payment schedule"
    _columns = {
                'date':fields.date('Payment date'),
                'amount':fields.integer('Payment amount'),
                'percent':fields.integer('Contract percent'),
                'contract_history_id': fields.many2one('contract.history', 'Contract History'),
                'loss': fields.float('Loss', readonly = True),
              }
    _defaults = {
                'amount': 0,
                }
   

    
  