# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2014-2020 ShineERP Co.,ltd (<http://www.serp.mn>). 
#    All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, 205, ShineERP LLC
#    Email : info@serp.mn
#    Phone : 976 + 11-89060761, 97119993
#
##############################################################################

from openerp.osv import osv
from openerp.report import report_sxw
#from common_report_header import common_report_header

class contract_history(report_sxw.rml_parse):
    name = 'report.ierp_contract.contract.history.garage'
    
    def set_context(self, objects, data, ids, report_type=None):
        new_ids = ids
        return super(contract_history, self).set_context(objects, data, new_ids, report_type=report_type)
    
    def __init__(self, cr, uid, name, context=None):
        if context is None:
            context = {}
        super(contract_history, self).__init__(cr, uid, name, context=context)
        self.context = context
    
class report_contract_history_garage(osv.AbstractModel):
    
    ''' Contract history garage
    '''
    _name = 'report.ierp_contract.report_contract_history_garage'
    _inherit = 'report.abstract_report'
    _template = 'ierp_contract.report_contract_history_garage'
    _wrapped_report_class = contract_history
    
    

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: