# -*- coding: utf-8 -*-

import logging
import time
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp.tools.translate import _
from lxml import etree
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta
import sys
reload(sys)
sys.setdefaultencoding('utf-8')
#from openerp.modules.registry import RegistryManager
#from openerp.api import Environment

class create_mail_contract(osv.osv_memory):
    
    _name = "create.mail.contract"
    _description = "Create mail of Contract"
    
    _columns = {
    }
    
    def tbab_create_mail(self, cr, uid, ids, context=None):
        print 'Гэрээнүүдээс ноорог мэйл үүсгэгдэж байна...'
        
        task_obj = self.pool.get('work.performance.contract')
        base_url = self.pool.get('ir.config_parameter').get_param(cr, uid, 'web.base.url')
        
        mail_out_obj = self.pool.get('ir.mail_server').search(cr, uid, [('id','=','1')])
        mail_out_obj_id = self.pool.get('ir.mail_server').browse(cr, uid, mail_out_obj)
        print 'Гарах мэйлийн Хэрэглэгчийн нэр болон Холболтын нууцлал', mail_out_obj_id, mail_out_obj_id.smtp_user, mail_out_obj_id.smtp_encryption
        
        company_html = '''<br /><small>Номин Констракшн ХХК компаниас <a style='color:inherit' href='https://www.odoo.com/'>Odoo</a>-г ашиглан илгээгдсэн</small>'''
        
        if context is None:
            context = {}
            
        cr.execute("""select *
                        from 
                            work_performance_contract as pt 
                        where
                            pt.user_mail_created = False or
                            pt.controlled_mail_created = False or
                            pt.budget_mail_created = False or
                            pt.coordinator_mail_created = False or
                            pt.contract_project_mail_created = False or
                            pt.headman_mail_created = False or
                            pt.project_headman_mail_created = False or
                            pt.building_director_mail_created = False or
                            pt.executive_director_mail_created = False or
                            pt.approved_mail_created = False or
                            pt.to_conclude_mail_created = False or
                            pt.concluded_mail_created = False
                            """)
        task_info  = cr.dictfetchall()
        #print 'jjjjjjjjjjkkkkkkkl', task_info, task_info['state']
        #Huuliin albanii odoogoor baigaa ajilchdiin mail bolon ners ololt
        tbab_law_emp_mail = []
        tbab_manager_mail = []
        tbab_headman_mail = []
        
        tbab_law_emp_name = []
        tbab_manager_name = []
        tbab_headman_name = []
        
        res_users_obj = self.pool.get('res.users')
        res_ids = res_users_obj.search(cr,uid,[])
        for line in res_users_obj.browse(cr, uid, res_ids):
            if_group_contract_officer = line.has_group('ierp_contract.group_contract_officer')
            if_group_contract_manager = line.has_group('ierp_contract.group_contract_manager')
            if_group_contract_headman = line.has_group('ierp_contract.group_contract_headman')
            
            if if_group_contract_officer == True and if_group_contract_manager == False and if_group_contract_headman == False:
                tbab_law_emp_mail = tbab_law_emp_mail + [(4,[line.login])]
                tbab_law_emp_name = tbab_law_emp_name + [(4,[line.name])]
            elif if_group_contract_officer == True and if_group_contract_manager == True and if_group_contract_headman == False:
                tbab_manager_mail = tbab_manager_mail + [(4,[line.login])]
                tbab_manager_name = tbab_manager_name + [(4,[line.name])]
            elif if_group_contract_officer == True and if_group_contract_manager == True and if_group_contract_headman == True:
                tbab_headman_mail = tbab_headman_mail + [(4,[line.login])]
                tbab_headman_name = tbab_headman_name + [(4,[line.name])]
        print 'law_OFFICER', tbab_law_emp_mail
        print 'law_MANAGER', tbab_manager_mail
        print 'law_HEADMAN', tbab_headman_mail
        #Huuliin albanii ajilchdiin ners
        officer_html = ''
        for officer_htmls in tbab_law_emp_name:
            officer_html = officer_html + ',' + officer_htmls[1][0]
        manager_html = ''
        for manager_htmls in tbab_manager_name:
            manager_html = manager_html + ',' + manager_htmls[1][0]
        headman_html = ''
        for headman_htmls in tbab_headman_name:
            headman_html = headman_html + ',' + headman_htmls[1][0]
        #Huuliin albanii ajilchdiin mailvvd
        officer_mails_list = ''
        for officer_mails in tbab_law_emp_mail:
            officer_mails_list = officer_mails_list + ',' + officer_mails[1][0]
        manager_mails_list = ''
        for manager_mails in tbab_manager_mail:
            manager_mails_list = manager_mails_list + ',' + manager_mails[1][0]
        headman_mails_list = ''
        for headman_mails in tbab_headman_mail:
            headman_mails_list = headman_mails_list + ',' + headman_mails[1][0]
        
        
        for tasksuud in task_info:
            tasks = task_obj.browse(cr, uid, tasksuud['id'])
            tbab_to_mail = ''
            tbab_cc_mail = ''
            to_html = ''
            orshil_link = ''
            mail_states = {}
            if tasks:
                print 'qqqqqqqqqqqqqqqqq', tasks.state
                tbab_user_mail = tasks.user_id.login
                tbab_quantity_surveyor_mail = tasks.quantity_surveyor.login
                tbab_coordinator_mail = tasks.coordinator_name.login
                tbab_project_headman_mail = tasks.headman_name.login
                tbab_building_director_mail = tasks.consumer_name.login
                tbab_executive_director_mail = tasks.executive_director.login
                tbab_economist_mail = tasks.economist.login
                
                html_contractor_company = '''<br /> \n Гэрээлэгч (компани) - <b>%s</b>'''%tasks.contractor_company.name
                html_contractor_name = '''<br /> \n Гэрээлэгч (хүн буюу хариуцагч) - <b>%s</b>'''%tasks.contractor_name.name
                html_contractor_job = '''<br /> \n Гэрээлэгчийн албан тушаал - <b>%s</b>'''%tasks.contractor_job
                html_contractor_phone= '''<br /> \n Гэрээлэгчийн утас - <b>%s</b>'''%tasks.contractor_phone
                #html_type = tasks.type
                
                if tasks.state == 'budget':
                    tbab_to_mail = tbab_quantity_surveyor_mail
                    tbab_cc_mail = tbab_user_mail + tbab_coordinator_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + officer_mails_list + ',' + manager_mails_list + ',' + headman_mails_list
                    to_html = tasks.quantity_surveyor.name
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээ бүртгэгдсэн байна. Та мэдээлэл оруулах шаардлагатай бол яаралтай оруулна уу.'''%tasks.contract_number
                    mail_states = {
                                'user_mail_created' : True,
                                'controlled_mail_created' : True,
                                'budget_mail_created' : True,
                                'coordinator_mail_created' : True,
                                'contract_project_mail_created' : True,
                                'headman_mail_created' : True,
                                'project_headman_mail_created' : True,
                                'building_director_mail_created' : True,
                                'executive_director_mail_created' : True,
                                'approved_mail_created' : True,
                                'law_dep_mail_created' : True,
                                'to_conclude_mail_created' : True,
                                'concluded_mail_created' : True,
                                }
                
                elif tasks.state == 'coordinator':
                    tbab_to_mail = tbab_coordinator_mail
                    #tbab_cc_mail = tbab_quantity_surveyor_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + officer_mails_list + ',' + manager_mails_list + ',' + headman_mails_list
                    to_html = tasks.coordinator_name.name
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээний мэдээлэлд засвар орсон байна. Та яаралтай мэдээлэл ээ оруулна уу.'''%tasks.contract_number
                    mail_states = {
                                'coordinator_mail_created' : True,
                                }
                    
                elif tasks.state == 'project':
                    tbab_to_mail = officer_mails_list
                    #tbab_cc_mail = tbab_quantity_surveyor_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + tbab_coordinator_mail + ',' + manager_mails_list + ',' + headman_mails_list
                    tbab_cc_mail = manager_mails_list
                    to_html = officer_html
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээний мэдээлэлд Гэрээний төслийн мэдээлэл оруулахад бэлэн болсон байна. Та яаралтай мэдээлэл ээ оруулна уу.'''%tasks.contract_number
                    mail_states = {
                                'contract_project_mail_created' : True,
                                }
                    
                elif tasks.state == 'law_headman':
                    tbab_to_mail = headman_mails_list
                    #tbab_cc_mail = tbab_quantity_surveyor_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + tbab_coordinator_mail + ',' + manager_mails_list + ',' + headman_mails_list
                    to_html = headman_html
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээний мэдээлэлд Хуулийн албаны даргын зөвшөөрөл хүлээгдэж байна. Та батална уу.'''%tasks.contract_number
                    mail_states = {
                                'headman_mail_created' : True,
                                }
                    
                elif tasks.state == 'project_headman':
                    tbab_to_mail = tbab_project_headman_mail
                    #tbab_cc_mail = tbab_quantity_surveyor_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + tbab_coordinator_mail + ',' + manager_mails_list + ',' + headman_mails_list
                    to_html = tasks.headman_name.name
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээний мэдээлэлд Төслийн албаны даргын зөвшөөрөл хүлээгдэж байна. Та батална уу.'''%tasks.contract_number
                    mail_states = {
                                'project_headman_mail_created' : True,
                                }
                    
                elif tasks.state == 'building_director':
                    tbab_to_mail = tbab_building_director_mail
                    #tbab_cc_mail = tbab_quantity_surveyor_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + tbab_coordinator_mail + ',' + manager_mails_list + ',' + headman_mails_list
                    to_html = tasks.consumer_name.name
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээний мэдээлэлд Барилга архитектур эрхэлсэн захирлын зөвшөөрөл хүлээгдэж байна. Та батална уу.'''%tasks.contract_number
                    mail_states = {
                                'building_director_mail_created' : True,
                                }
                    
                elif tasks.state == 'executive_director':
                    tbab_to_mail = tbab_executive_director_mail
                    #tbab_cc_mail = tbab_quantity_surveyor_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + tbab_coordinator_mail + ',' + manager_mails_list + ',' + headman_mails_list
                    to_html = tasks.executive_director.name
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээний мэдээлэлд Гүйцэтгэх захирлын зөвшөөрөл хүлээгдэж байна. Та батална уу.'''%tasks.contract_number
                    mail_states = {
                                'executive_director_mail_created' : True,
                                }
                    
                elif tasks.state == 'approved':
                    tbab_to_mail = manager_mails_list
                    #tbab_cc_mail = tbab_quantity_surveyor_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + tbab_coordinator_mail + ',' + manager_mails_list + ',' + headman_mails_list
                    tbab_cc_mail = tbab_user_mail
                    to_html = manager_html
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээ батлагдсан байна.'''%tasks.contract_number
                    mail_states = {
                                'user_mail_created' : True,
                                'approved_mail_created' : True,
                                }
                    
                elif tasks.state == 'conclude':
                    tbab_to_mail = tbab_economist_mail
                    #tbab_cc_mail = tbab_quantity_surveyor_mail + ',' + tbab_project_headman_mail + ',' + tbab_building_director_mail + ',' + tbab_executive_director_mail + ',' + tbab_economist_mail + ',' + tbab_coordinator_mail + ',' + manager_mails_list + ',' + headman_mails_list
                    to_html = tasks.economist.name
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээг дүгнэхэд бэлэн болсон байна. Та гэрээг дүгнэх ажлыг яаралтай хийнэ үү.'''%tasks.contract_number
                    mail_states = {
                                'to_conclude_mail_created' : True,
                                }
                    
                elif tasks.state == 'concluded':
                    tbab_to_mail = headman_mails_list
                    tbab_cc_mail = manager_mails_list
                    to_html = headman_html
                    orshil_link = '''<br /> \n Энэхүү <b>%s</b> - дугаартай Гэрээ дүгнэгдлээ. Танд баяр хүргэе.'''%tasks.contract_number
                    mail_states = {
                                'concluded_mail_created' : True,
                                }
                    
                
            
            holboos_link = '''<br /><br />Та дэлгэрэнгүй мэдээллийг <a style='color:#00ccff' href='%s/web?db=%s#id=%s&amp;view_type=form&amp;model=work.performance.contract&menu_id=%s&action=%s'>Гэрээний мэдээлэл</a> - холбоосоор орж үзнэ үү<br />\n ------------------------- '''% (base_url, cr.dbname, tasks.id, 927, 1817)
            company_html = '''<br /><br /><small>Баярлалаа, </small>'''
            job_html_link = '''<br /> \n NCDERP систем '''
            
            
            body_html = 'Эрхэм %s, <br /> '%(to_html or 'Танд') + orshil_link  + holboos_link + html_contractor_company + html_contractor_name + html_contractor_job + html_contractor_phone + company_html + job_html_link
            
            
            send_mail_obj = self.pool.get('mail.mail')
            email_template_id = {
                                'subject' : tasks.name + ' - ' + 'гэрээ',
                                'body_html': body_html,
                                'email_from' : mail_out_obj_id.smtp_user,
                                'type' : 'email',
                                'auto_delete' : True,
                                'notification' : True,
                                'model' : 'work.performance.contract',
                                'email_to' : tbab_to_mail,
                                'email_cc' : tbab_cc_mail or '',
                                #'recipient_ids' : tbab_partner_mail,
                                }
            mail_id = send_mail_obj.create(cr, uid, email_template_id, context=None)
            print 'cccccccccccccccc', mail_states
            tasks.write(mail_states, context=None)
        
        return True
