#-*- coding: utf-8 -*-
#Tb25 shine barimtiin menejmentiin module
#NCD-n barimtiin bvrtgeliin ontslogt tohiruulan hogjvvlew

import sys
reload(sys)
sys.setdefaultencoding('utf-8')

import logging
from datetime import date, timedelta, datetime
from dateutil.relativedelta import relativedelta
from operator import itemgetter
import time

import openerp
from openerp import models,  api, _
from openerp import SUPERUSER_ID, api
from openerp import tools
from openerp.osv import fields, osv, expression
from openerp.tools.translate import _
from openerp.tools.float_utils import float_round as round

import openerp.addons.decimal_precision as dp

_logger = logging.getLogger(__name__)


class ir_attachment(osv.osv):
    _inherit = 'ir.attachment'
    #_inherit = ['ir.attachment','mail.thread', 'ir.needaction_mixin']
    #_inherits = ['mail.message', 'ir.needaction_mixin']
    _columns = {
               'doc_summary':fields.char('Doc summary'),
               'doc_date':fields.date('Doc date', required=True),
               'doc_number':fields.char('Doc number',copy=False),
               'doc_type':fields.selection([('sent_paper','Sent paper'),('received_paper','Received paper'),('decree','Decree'),('request','Request')],'Doc type'),
               #yawsan bichig
               'to_whom':fields.many2one('res.partner','To whom'),
               'from_who':fields.many2one('res.company','From who'),
               #irsen bichig
               'rec_comp_id':fields.many2one('res.company','Received company'),
               'rec_date':fields.date('Received date'),
               'from_where':fields.char('From where'),
               #'res_users_id':fields.many2many('res.users','user_id','doc_user_rel','doc_user_id','Received employee'),
               'res_users_id':fields.many2many('hr.employee','emp_doc_id','doc_emp_rel','doc_emp_id','Received employee'),#Мэйл илгээх ажилчид
               'hamaatai_ids':fields.many2many('hr.employee','doc_hamaatai_id','hamaatai_rel','hamaatai_id','Hamaatai'),#Хамаатай ажилчид
               'how_to_solve':fields.text('How to solve'),
               'date_to_solve':fields.date('Date to solve'),
               'how_solved':fields.text('How solved'),
               'date_solved':fields.date('Date solved'),
               #tushaal
               'decr_timeframe':fields.date('Decr timeframe'),
               'decree_type':fields.selection([('legal_leaves','Legal leaves'),
                                            ('wage','Wage'),
                                            ('out_reason_type','Out reason type'),
                                            ('get_worker','Get worker'),
                                            ('appointment','Appointment'),
                                            ('commission','Commission')],'Decree type'),
               #'employee_id':fields.many2one('hr.employee','Employee'),
               'empl_id':fields.many2many('hr.employee','empl_id','leaves_empl_rel','doc_leaves_empl_id','Employee'),
               #'hr_job_id':fields.many2one('hr.job','HR job'),
               #tushaal - leaves
               'day':fields.integer('Day'),
               'leaves_start':fields.date('Leaves start'),
               'leaves_end':fields.date('Leaves end'),
               #tushaal - out_reasons
               'left_date':fields.date('Left date'),
               'out_reason':fields.selection([('company_decision','Company decision'),
                                            ('own_decision','Own decision'),
                                            ('down_sizing','Down sizing')],'Out reason'),
               
               'is_allowance':fields.boolean('Is allowance'),
               'allowance_amount':fields.integer('Allowance amount'),
               #tushaal - wages and get_workers
               'appointed_date':fields.date('Appointed date'),
               'work_type':fields.selection([('base','Base'),
                                            ('pilot','Pilot')],'Work type'),
               'date_wage':fields.date('Date wage'),
               'wage':fields.integer('Wage'),
               'wage_struct':fields.selection([('first','First'),
                                            ('second','Second'),
                                            ('third','Third'),
                                            ('fourth','Fourth'),
                                            ('fifth','Fifth'),
                                            ('sixth','Sixth')],'Wage struct'),
               'worker_start':fields.date('Worker start'),
               'worker_end':fields.date('Worker end'),
               'additional_wage_food':fields.integer('Additional wage food'),
               'additional_wage_drive':fields.integer('Additional wage drive'),
               'additional_wage_mobil':fields.integer('Additional wage mobil'),
               'additional_wage_square':fields.integer('Additional wage square'),
               # tushaal - Appointment
               'project_name':fields.char('Project name'),
               # tushaal - comiss tomilgoo
               'object_name':fields.char('Object name'),
               #'emp_line_id': fields.many2many('hr.employee','hr_emp_id','emp_line_hr_rel','doc_emps_id','EmpLineDoc'),
               #rhgfhgfhgfh99999999999999
               'assigned_to':fields.many2one('res.users','Assigned to'),#Хэнд цохсон
	             #mail yawsaniig shalgah talbaruud
               'send_to_participants':fields.boolean('Мэйл илгээх ажилчдыг сонгох'),
               'assigner_mail_created':fields.boolean('Цохсон хүнд мэйл илгээсэн эсэх'),#Цохсон хүнд мэйл илгээсэн эсэх
               'signal_mail_created':fields.boolean('Шийдвэрлэх хугацаанд мэйл илгээсэн эсэх'),#Шийдвэрлэх хугацаанд мэйл илгээсэн эсэх
               'state':fields.selection([('undone','Undone'),
                                            ('done','Done'),
                                            ('contracted','Contracted')],'State'),
               'approved_employee':fields.many2one('hr.employee','Approved employee'),#Баталсан ажилтан
               'approved_employee_dep':fields.many2one('hr.department','Approved employee dep'),#Хэлтэс
               'approved_date':fields.date('Approved date'),#Баталсан огноо
               'director_approved_date':fields.date('Director approved date'),#Захирлын баталсан огноо
                
                                            
               }
    _defaults = {
        'doc_number': lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'ir.attachment'),
        'doc_date': fields.date.context_today,
        'date_to_solve': date.today() + timedelta(days=14),
        'assigner_mail_created': False,
        'signal_mail_created': False,
        'state': 'undone',
        'send_to_participants': False,
    }
    #===========================================================================
    # def onchange_empl_id(self, cr, uid, ids, empl_id):
    #     result = {}
    #     #temdeglel
    #     #end hend tsohson gesen talbart songolt hiihed zaawal bvh ajiltnii medeelel harah
    #     #bas bvh companii medeelliig harah shaardlagatai bolchod bnaaaaaa
    #     users_obj = self.pool.get('res.users')
    #     users_id = users_obj.search(cr, uid, [('id','=',empl_id)])
    #     userss = users_obj.browse(cr, uid, users_id)
    #     
    #     sd_obj = self.pool.get('hr.employee')
    #     sd_id = sd_obj.search(cr, uid, [('user_id','=',userss.id)])
    #     sd = sd_obj.browse(cr, uid, sd_id)
    #     
    #     if empl_id:
    #         result['value'] = {'hr_job_id':sd.job_id.id}
    #     else:
    #         result['value'] = {'hr_job_id':False}
    #     return result
    #===========================================================================
    
    def action_to_done(self, cr, uid, ids, *args):
    	obj = self.browse(cr, uid,ids)
    	
    	if obj.how_solved == False:
    		raise osv.except_osv(_("Алдаа!"), _("Та хэрхэн шийдвэрлэсэн эсэхээ бөглөнө үү!"))
    
    	if obj.date_solved == False:
    		raise osv.except_osv(_("Алдаа!"), _("Та шийдвэрлэсэн хугацааг бөглөнө үү!"))
        
        emp_obj_id = self.pool.get('hr.employee').search(cr,uid,[('user_id','=', uid)])
        emp_info = self.pool.get('hr.employee').browse(cr,uid,emp_obj_id)
        #print 'aaaaaaaa', emp_obj_id, emp_info
        self.write(cr, uid, ids, {
                                  'approved_employee': emp_info.id,
                                  'approved_employee_dep': emp_info.department_id.id,
                                  'approved_date': date.today(),
                                  'state': 'done',
                                  })
        
        return True
    def action_to_undone(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {
                                    'approved_employee': False,
                                    'approved_date': False,
                                    'state': 'undone',
                                    })
        return True
    def action_to_contracted(self, cr, uid, ids, *args):
        self.write(cr, uid, ids, {'state': 'contracted',
                                    })
        return True

    def onchange_doc_type(self, cr, uid, ids, doc_type):
        result = {}
        if doc_type != 'decree':
            result['value'] = {'decree_type':'','work_type':''}
        return result

    #===========================================================================
    # def onchange_doc_date(self, cr, uid, ids, doc_date):
    #     result = {}
    #     #=======================================================================
    #     # if doc_date:
    #     #     result['date_to_solve'] = date.today() + timedelta(days=14)
    #     #=======================================================================
    #     result['date_to_solve'] = date.today() + timedelta(days=14)
    #     print 'fffff', result
    #     return result
    #===========================================================================
    
    def onchange_assigned_to(self, cr, uid, ids, assigned_to):
	result = {}
	obj = self.browse(cr, uid,ids)
	if_helper_director = self.pool['res.users'].has_group(cr, uid, 'ierp_hr.group_helper_director')
	if if_helper_director:
		if assigned_to:
		    result['value'] = {'assigner_mail_created':False}
	else:
		pass
        return result
    
    def onchange_res_users_id(self, cr, uid, ids, res_users_id):  
	result = {}
	obj = self.browse(cr, uid,ids)
	#if_helper_director = self.pool['res.users'].has_group(cr, uid, 'ierp_hr.group_helper_director')
	#if if_helper_director:
	if res_users_id:
	    result['value'] = {'assigner_mail_created':False}
	#else:
	#	pass
        return result
    
    def onchange_date_to_solve(self, cr, uid, ids, date_to_solve):     
	result = {}
	obj = self.browse(cr, uid,ids)
	if_helper_director = self.pool['res.users'].has_group(cr, uid, 'ierp_hr.group_helper_director')
	if if_helper_director:
		if date_to_solve:
		    result['value'] = {'signal_mail_created':False}
	else:
		pass
        return result
    
    

    def create(self, cr, uid, values, context=None):
        self.check(cr, uid, [], mode='write', context=context, values=values)
        #dadada = fields.date.context_today + timedelta(days=14)
        #print 'pppppppppp', dadada
        #values['date_to_solve'] = date.today() + timedelta(days=14)
        if 'file_size' in values:
            del values['file_size']
        return super(ir_attachment, self).create(cr, uid, values, context)

    def write(self, cr, uid, ids, vals, context=None):
        if isinstance(ids, (int, long)):
            ids = [ids]
        
        #added codes start
        obj = self.browse(cr, uid,ids)
        if_helper_director = self.pool['res.users'].has_group(cr, uid, 'ierp_hr.group_helper_director')
        rp_zasch_bolno = 0 # irsen bichgiig zasch bolno - can edit received_paper
        if not if_helper_director:
            if obj.doc_type == 'received_paper':
                if obj.res_users_id: # hend tsohsond songogdson baigaa hvn tuhain barimtiig harna gedeg dvrem bichih tul ene nohtsliin esreg nohtsliig orhison bolno
                    for received_users in obj.res_users_id:
                        for line in received_users:
                            if line.user_id.id == uid or obj.assigned_to.id==uid:#nemsen
                                rp_zasch_bolno = rp_zasch_bolno + 1
                            else:
                                pass
                    if rp_zasch_bolno > 0:
                        #print 'cccccc', received_users, uid
                        if 'how_solved' in vals:
                            vals['how_solved'] = vals['how_solved']
                        if 'date_solved' in vals:
                            vals['date_solved'] = vals['date_solved']
                        #vals['context'] = obj.context
                        vals['name'] = obj.name
                        vals['type'] = obj.type
                        #vals['datas'] = obj.datas
                        vals['user_id'] = obj.user_id.id
                        vals['doc_summary'] = obj.doc_summary
                        vals['doc_date'] = obj.doc_date
                        vals['doc_number'] = obj.doc_number
                        vals['doc_type'] = obj.doc_type
                        vals['parent_id'] = obj.parent_id.id
                        vals['partner_id'] = obj.partner_id.id
                        vals['company_id'] = obj.company_id.id
                        vals['rec_comp_id'] = obj.rec_comp_id.id
                        vals['rec_date'] = obj.rec_date
                        vals['from_where'] = obj.from_where
                        #vals['res_users_id'] = obj.res_users_id
                        print 'ffffffff', vals['date_to_solve'], obj.date_to_solve
                        vals['how_to_solve'] = obj.how_to_solve
                        vals['date_to_solve'] = obj.date_to_solve
                        vals['assigned_to'] = obj.assigned_to.id#nemsen
                        #vals['send_to_participants'] = obj.send_to_participants
                        #vals['hamaatai_ids'] = obj.hamaatai_ids
                    else:
                        raise osv.except_osv(_("Алдаа!"), _("Та энэхүү баримтанд өөрчлөлт оруулах эрхгүй байна! Хэнд цохсон талбарт та сонгогдсон бол зөвхөн <<Хэрхэн шийдвэрлэсэн, Шийдвэрлэсэн хугацаа, Тайлбар>> гэсэн 3 талбарыг л засч болно."))
                #elif obj.state == 'contracted':
                #    raise osv.except_osv(_("Алдаа!"), _("Та энэхүү баримтанд өөрчлөлт оруулах эрхгүй байна! Гэрээ байгуулсан төлөвтэй байхад баримтыг засч болохгүй."))
                
                    
        #added codes end
	
        self.check(cr, uid, ids, 'write', context=context, values=vals)
        if 'file_size' in vals:
            del vals['file_size']
        return super(ir_attachment, self).write(cr, uid, ids, vals, context)
    
    
    
    
    
    
