# -*- coding: utf-8 -*-
from report import report_sxw
import time
from osv import osv
import datetime
from tools.translate import _

class report_not_paid_loan(report_sxw.rml_parse):
	_name = 'report.not.paid.loan'
	
	def _get_loans(self,cr,uid,context):
		product_id = context['product']
		loan_id = []
		if product_id:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','in',['paid']),('product_id','=',product_id[0])])
		else:
			loids = self.pool.get('loan.order').search(cr,uid,[('state','in',['paid'])])
		
		if loids != []:
			loans = self.pool.get('loan.order').browse(cr,uid,loids)
			for loan in loans:
				self.get_total_amount += loan.loan_balance
				for line in loan.schedules:
					if line.is_paid == 'un_paid':
						return loans


	def _get_user(self,cr,uid,context):
		user = self.pool.get('res.users').browse(cr,uid,uid)
		return user.name
	def _get_total_amount(self):
		return self.get_total_amount
	
	def _get_total_xxt(self):
		return self.get_total_xxt
    
	def __init__(self, cr, uid, name, context):
		super(report_not_paid_loan, self).__init__(cr, uid, name, context=context)
		self.get_total_amount = 0
		self.get_total_xxt = 0
		self.localcontext.update({
			'user':self._get_user(cr,uid,context),
			'time':time,
			'from_date':context['from_date'],
        	'to_date':context['to_date'],
        	'loans':self._get_loans(cr,uid,context),
         	'get_total_amount':self._get_total_amount,
         	'get_total_xxt':self._get_total_xxt,
        })
	
report_sxw.report_sxw('report.not.paid.loan', 'loan.order', 'addons/bbsb_loan/report/report_3_not_paid_loan.rml', parser=report_not_paid_loan, header = False )

