# -*- encoding: utf-8 -*-
import time
from openerp.osv import osv, fields
import datetime
from dateutil import parser
from openerp.tools.translate import _

class not_paid_report_wizard(osv.osv_memory):
	_name = 'not.paid.report.wizard'
	_description = 'Not Paid Report Wizard'
	
	_columns = {
		'note':fields.char(u'Тайлангийн нэр',size=64,readonly=True),
		'from_date': fields.date(u'Эхлэх огноо',required=True),
		'to_date': fields.date(u'Дуусах огноо',required=True),
		'product':fields.many2one('loan.product',u'Зээлийн бүтээгдэхүүн',domain="[('loan_product_type','in',['loan_product'])]"),

	}
	
	_defaults = {
        'note': u'Төлөлт хийглээгүй зээлийн тайлан',
        'from_date': lambda * a: time.strftime('%Y-01-01'),
        'to_date': fields.date.context_today,
    }
	def print_report(self, cr, uid, ids, context=None):
		data = self.read(cr,uid,ids,[])[0]
		print data,'------------------------'
		context['from_date'] = data['from_date']
		context['to_date'] = data['to_date']
		context['product'] = data['product']
		return {
            'type'         : 'ir.actions.report.xml',
            'context':context,
            'report_name'   : 'not.paid.loan',
            'datas': {
                    'model':'loan.payment',
                    'id': context.get('active_ids') and context.get('active_ids')[0] or False,
                    'ids': context.get('active_ids') and context.get('active_ids') or [],
                    'report_type': 'pdf',
                    'form':data,
                },
            'nodestroy': False
        }
    	
not_paid_report_wizard()
