# -*- encoding: utf-8 -*-
import time
from openerp.osv import osv, fields
import datetime
from dateutil import parser
from openerp.tools.translate import _

class collateral_report_wizard(osv.osv_memory):
	_name = 'collateral.report.wizard'
	_description = 'Collateral Report Wizard'
	
	_columns = {
		'note':fields.char(u'Тайлангийн нэр',size=64,readonly=True),
		'from_date': fields.date(u'Эхлэх огноо',required=True),
		'to_date': fields.date(u'Дуусах огноо',required=True),
	}
	
	_defaults = {
        'note': u'Барьцаа хөрөнгийн тайлан',
        'from_date': lambda * a: time.strftime('%Y-01-01'),
        'to_date': fields.date.context_today,
    }
	def print_report(self, cr, uid, ids, context=None):
		data = self.read(cr,uid,ids,[])[0]
		print data,'------------------------'
		context['from_date'] = data['from_date']
		context['to_date'] = data['to_date']
		
		return {
            'type'         : 'ir.actions.report.xml',
            'context':context,
            'report_name'   : 'collateral',
            'datas': {
                    'model':'loan.payment',
                    'id': context.get('active_ids') and context.get('active_ids')[0] or False,
                    'ids': context.get('active_ids') and context.get('active_ids') or [],
                    'report_type': 'pdf',
                    'form':data,
                },
            'nodestroy': False
        }
    	
collateral_report_wizard()
