from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp



class marketing_contract_type(osv.osv):
    _name = 'marketing.contract.type'
    _columns ={
        'name':fields.char('Name'),   
               }


class marketing_contract(osv.osv):
    _inherit = 'account.analytic.account'
    _columns = {               
        'mark_contract_amount':fields.float('Contract_amount'),
        'mark_customer_id': fields.many2one('res.partner','Customer'),
        'street': fields.char('Street'),  
        'city': fields.char('City'),
        'country_id': fields.char('Country'),
        'website': fields.char('Website'),
        'phone': fields.char('Phone'),
        'mobile': fields.char('Mobile'),
        'fax': fields.char('Fax'),
        'email': fields.char('Email'),  
        'mark_contract_type_id': fields.many2one('marketing.contract.type','Contract type'),
        'approved_person_id':fields.many2one('hr.employee', 'Approved person'),
        'delegate_person_id':fields.many2one('hr.employee', 'Delegate person'),
        'mark_payment_schedule_id':fields.one2many('marketing.payment.schedule','contract_id','Payment schedule'),
             }
    
class mark_payment_schedule(osv.osv):
    _inherit = 'marketing.payment.schedule'
    _columns = {               
                'date': fields.date('Payment date'),
                'amount': fields.integer('Payment amount'),
                'contract_id': fields.many2one('account.analytic.account', 'Sales Contract'),
                }