from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp


class building_note(osv.osv):
    _name = 'building.note'
    _description = "Building note"
    _columns = {
                'name':fields.char('Name',required=True),
                'project_id':fields.many2one('project.project', 'Project'),
                'customer_id':fields.many2one('res.partner', 'Customer'),
                'building_id':fields.many2one('building.building', 'Building'),
                'door_id':fields.many2one('product.product', 'Door'),
                #'floor':fields.char('Floor'),
                'note_type': fields.selection([
                                    ('process', 'Process'),
                                    ('measure', 'Measure'),
                                    ('obtrusion', 'Obtrusion'),                                    
                                    ], 'Note type', select=True, required=True),
                'designer_id':fields.many2one('res.users', 'Designer'),
                'date':fields.datetime('Date'),
                'building_people':fields.integer('Building people'),
                #'respondent':fields.many2one('hr.employee', 'Respondent'),
                'note':fields.text('Note'),
                     #'state': fields.selection([
                                    #('draft', 'Draft'),
                                    #('confirm', 'Confirm'),
                                   #('done','Done'),
                                    #('cancel','Cancel'),                                    
                                    #], 'State', select=True, readonly=True),                              
                }
    
    
    _defaults = {
              
                'date': lambda obj, cr, uid, context: time.strftime('%Y-%m-%d'),
                'designer_id': lambda obj, cr, uid, context: uid,
                }
