# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 iERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : iERP@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp


    
class sale_order_line(osv.osv):
    _inherit = 'sale.order.line'
    
    _columns = {
                'is_price_type':fields.boolean('Is price type'),
                'price_type':fields.selection([('sale_price','Sale price'),
                                                  ('disbursing_price','Disbursing_price'),
                                                  ('retail_price','Retail price')],'Price type',required=True),
                }
    _defaults = {
                 'price_type':'sale_price',
                 }
    

    def onchange_price(self, cr, uid, ids, pro_id,type,context=None):
        res = {}
        product = self.pool.get('product.product')
        if type == 'sale_price':
            if pro_id !=False:
                pro = product.browse(cr, uid, pro_id)
                res = {'price_unit':pro.lst_price
                     }
        if type == 'disbursing_price':
            if pro_id !=False:
                pro = product.browse(cr, uid, pro_id)
                res = {'price_unit':pro.lst_price
                     }
        if type == 'retail_price':
            if pro_id !=False:
                pro = product.browse(cr, uid, pro_id)
                res = {'price_unit':pro.lst_price
                     }
            
            
        return {'value':res}
        
    

