# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class sale_detailed_plan(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "sale.detailed.plan"
    _description = "Sale detailed plan"
    
    _columns = {
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        
       
        sheet.write_merge(1, 1, 1, 7, u'Төслийн гэрээний борлуулалтын дэлгэрэнгүй төлөвлөгөө (Хугацаатай)', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(3, 3, 1, 1, u'Төслийн нэр:',style_noborder)
        sheet.write_merge(5, 6, 0, 0, u'№',stylebr1) 
        sheet.write_merge(5, 6, 1, 1, u'Байрны дугаар',stylebr1)
        sheet.write_merge(5, 6, 2, 2, u'Давхар',stylebr1)
        sheet.write_merge(5, 6, 3, 3, u'Төрөл',stylebr1)
        sheet.write_merge(5, 6, 4, 4, u'Тоот',stylebr1)
        sheet.write_merge(5, 6, 5, 5, u'Талбайн хэмжээ',stylebr1)
        sheet.write_merge(5, 6, 6, 6, u'Байрны код',stylebr1)
        sheet.write_merge(5, 6, 7, 7, u'Үйлчилгээний төрөл',stylebr1)
        sheet.write_merge(5, 6, 8, 8, u'Түрээсийн сар',stylebr1)
        sheet.write_merge(5, 6, 9, 9, u'Борлуулах үнэ (Төгрөгөөр)',stylebr1)
        sheet.write_merge(5, 6, 10, 10, u'2014-1',stylebr1)
        sheet.write_merge(5, 6, 11, 11, u'2014-2',stylebr1)
        sheet.write_merge(5, 6, 12, 12, u'2014-3',stylebr1)
        sheet.write_merge(5, 6, 13, 13, u'2014-4',stylebr1)
        sheet.write_merge(5, 6, 14, 14, u'2014-5',stylebr1)
        sheet.write_merge(5, 6, 15, 15, u'2014-6',stylebr1)
        sheet.write_merge(5, 6, 16, 16, u'2014-7',stylebr1)
        sheet.write_merge(5, 6, 17, 17, u'2014-8',stylebr1)
        sheet.write_merge(5, 6, 18, 18, u'2014-9',stylebr1)
        sheet.write_merge(5, 6, 19, 19, u'2014-10',stylebr1)
        sheet.write_merge(5, 6, 20, 20, u'2014-11',stylebr1)
        sheet.write_merge(5, 6, 21, 21, u'2014-12',stylebr1)
      
       
         
      
        inch = 1000
        sheet.col(0).width = 700
        sheet.col(1).width = 2*inch
        sheet.col(2).width = 2*inch #shirheg
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 2*inch
        sheet.col(5).width = 2*inch
        sheet.col(6).width = 2*inch
        sheet.col(7).width = 5*inch
        sheet.col(8).width = 2*inch
        sheet.col(9).width = 4*inch
        sheet.col(10).width = 2*inch
        sheet.col(11).width = 2*inch
        sheet.col(12).width = 2*inch
        sheet.col(13).width = 2*inch
        sheet.col(14).width = 2*inch
        sheet.col(15).width = 2*inch
        sheet.col(16).width = 2*inch
        sheet.col(17).width = 2*inch
        sheet.col(18).width = 2*inch
        sheet.col(19).width = 2*inch
        sheet.col(20).width = 2*inch
        sheet.col(21).width = 2*inch
     
        
    
        return {'data':book}

sale_detailed_plan()