# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    
#
##############################################################################

import logging
import time
import datetime
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv, orm
from openerp.tools import float_is_zero
from openerp.tools.translate import _
from calendar import month, day_abbr, day_name
from dateutil import rrule
import math
from dateutil.relativedelta import relativedelta
from openerp.exceptions import except_orm
from openerp.exceptions import Warning
#import pymsgbox

class emp_on_user(osv.osv):
    _inherit = 'res.users'
    
    _columns = {
        'tbab_emp_id': fields.many2one('hr.employee', 'Холбоотой ажилтан'),
        
    }
    
class emp_id_to_user(osv.osv):
    _name = 'emp.id.to.user'
    
    #===========================================================================
    # _columns = {
    #     'tbab_emp_id': fields.many2one('hr.employee', 'Холбоотой ажилтан'),
    #     
    # }
    #===========================================================================
    def update_job_nonactive_emps(self, cr, uid, ids, context=None):
        empl_obj = self.pool.get('hr.employee').search(cr, uid, [('active','=',False)])
        empdd = self.pool.get('hr.employee').browse(cr, uid, empl_obj)
        i = 0#ajliin bair bgaa ajilchdiin too
        j = 0#ajliin bair baihgvi ajilchdiin too
        n = 0#Odoogiin niit Идэвхтэй болон Пайзтай ажилтнуудын тоо
        print 'hr.employee-s Идэвхтэй болон Пайзтай ажилтнуудыг дуудав', empl_obj, empdd
        for emp_line in empdd:
            print 'Ажилтан бүрээрх давталт', emp_line
            if emp_line.job_id:
		i = i + 1
                print 'Ажилтны ID, Ажилтны нэр, Хэрэглэгчийн ID, Хэрэглэгчийн нэр', emp_line.id, emp_line.name, emp_line.job_id, emp_line.job_id.name
		emp_line.write({'job_id': emp_line.job_id.id})
            else:
		j = j + 1
	n = i + j
	#print 'Хэрэглэгч дээрх ажилтны ID зөрсөн', n
	print 'Нийт Ажлын байр байгаа ажилтны тоо', i
	print 'Нийт Ажлын байр байхгүй ажилтны тоо', j
	print 'Нийт шалгасан ажилтны тоо', i+j
        
        return True
    
    def update_job_id(self, cr, uid, ids, context=None):
        #empl_obj = self.pool.get('hr.employee').search(cr, uid, [('active','=',True),('category_ids','!=',False)])
        empl_obj = self.pool.get('hr.employee').search(cr, uid, [('active','=',True)])
        empdd = self.pool.get('hr.employee').browse(cr, uid, empl_obj)
        i = 0#ajliin bair bgaa ajilchdiin too
        j = 0#ajliin bair baihgvi ajilchdiin too
        n = 0#Odoogiin niit Идэвхтэй болон Пайзтай ажилтнуудын тоо
        print 'hr.employee-s Идэвхтэй болон Пайзтай ажилтнуудыг дуудав', empl_obj, empdd
        for emp_line in empdd:
            print 'Ажилтан бүрээрх давталт', emp_line
            if emp_line.job_id:
		i = i + 1
                print 'Ажилтны ID, Ажилтны нэр, Хэрэглэгчийн ID, Хэрэглэгчийн нэр', emp_line.id, emp_line.name, emp_line.job_id, emp_line.job_id.name
		emp_line.write({'job_id': emp_line.job_id.id})
            else:
		j = j + 1
	n = i + j
	#print 'Хэрэглэгч дээрх ажилтны ID зөрсөн', n
	print 'Нийт Ажлын байр байгаа ажилтны тоо', i
	print 'Нийт Ажлын байр байхгүй ажилтны тоо', j
	print 'Нийт шалгасан ажилтны тоо', i+j
        
        return True and {

			    'warning': {

				'title': 'Амжилттай!',

				'message': 'sdfadfadfadsf'}

			}
    
    def compute_all_emp_id(self, cr, uid, ids, context=None):
        empl_obj = self.pool.get('hr.employee').search(cr, uid, [('active','=',True),('category_ids','!=',False)])
        empdd = self.pool.get('hr.employee').browse(cr, uid, empl_obj)
        i = 0
        j = 0
        n = 0
        print 'hr.employee-s Идэвхтэй болон Пайзгүй ажилтнуудыг дуудав', empl_obj, empdd
        for emp_line in empdd:
            print 'Ажилтан бүрээрх давталт', emp_line
            if emp_line.user_id:
                print 'Ажилтны ID, Ажилтны нэр, Хэрэглэгчийн ID, Хэрэглэгчийн нэр', emp_line.id, emp_line.name, emp_line.user_id, emp_line.user_id.name
                user_obj = self.pool.get('res.users')
                us_id = user_obj.search(cr, uid, [('id','=',emp_line.user_id.id),('active','=',True)])
                userdd = user_obj.browse(cr, uid, us_id)[0]
                print 'Хэрэглэгч дээрх ажилтны ID хоосон эсэх', userdd.tbab_emp_id.id
                if userdd.tbab_emp_id.id == False:
                    i = i + 1
                    userdd.write({'tbab_emp_id': emp_line.id})
                elif userdd.tbab_emp_id.id == emp_line.id:
                    pass
                    j = j + 1
                elif userdd.tbab_emp_id.id != emp_line.id:
                    pass
                    n = n + 1
                print 'Хэрэглэгч дээрх ажилтны ID зөрсөн', n
                print 'Нийт ID шидсэн ажилтны тоо', i
                print 'Нийт ID шидээгүй ажилтны тоо', j
                print 'Нийт шалгасан ажилтны тоо', i+j+n
                
        
        return True
        
