# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    
#
##############################################################################

import logging
import time
import datetime
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv, orm
from openerp.tools import float_is_zero
from openerp.tools.translate import _
from calendar import month, day_abbr, day_name
from dateutil import rrule
import math
from dateutil.relativedelta import relativedelta
from openerp.exceptions import except_orm
from openerp.exceptions import Warning
#import pymsgbox
    
class job_history(osv.Model):
    _name = 'job.history'
    
    _columns = {
                'hr_job_id': fields.many2one('hr.job', 'HR Job'),
                'hr_department_id': fields.many2one('hr.department', 'HR Department'),
                'no_of_employee': fields.integer('Current Number of Employees', copy=False, help="Ажиллаж буй ажилчдын тоо"),
                'no_of_recruitment': fields.integer('Expected New Employees', copy=False, help="Шинээр авах ажилчдын тоо"),
                'no_of_hired_employee': fields.integer('Hired Employees', copy=False, help="Ажлын байрны нийт ажилчдын тоо"),
                'history_date': fields.date('History Date'),
                #'hr_job_id': fields.many2one('hr.job', 'HR Job'),
         
    }
    
    #===========================================================================
    # def compute_all_emp_id(self, cr, uid, ids, context=None):
    #     empl_obj = self.pool.get('hr.employee').search(cr, uid, [('active','=',True),('category_ids','!=',False)])
    #     empdd = self.pool.get('hr.employee').browse(cr, uid, empl_obj)
    #     i = 0
    #     j = 0
    #     n = 0
    #     print 'hr.employee-s Идэвхтэй болон Пайзгүй ажилтнуудыг дуудав', empl_obj, empdd
    #     for emp_line in empdd:
    #         print 'Ажилтан бүрээрх давталт', emp_line
    #         if emp_line.user_id:
    #             print 'Ажилтны ID, Ажилтны нэр, Хэрэглэгчийн ID, Хэрэглэгчийн нэр', emp_line.id, emp_line.name, emp_line.user_id, emp_line.user_id.name
    #             user_obj = self.pool.get('res.users')
    #             us_id = user_obj.search(cr, uid, [('id','=',emp_line.user_id.id),('active','=',True)])
    #             userdd = user_obj.browse(cr, uid, us_id)[0]
    #             print 'Хэрэглэгч дээрх ажилтны ID хоосон эсэх', userdd.tbab_emp_id.id
    #             if userdd.tbab_emp_id.id == False:
    #                 i = i + 1
    #                 userdd.write({'tbab_emp_id': emp_line.id})
    #             elif userdd.tbab_emp_id.id == emp_line.id:
    #                 pass
    #                 j = j + 1
    #             elif userdd.tbab_emp_id.id != emp_line.id:
    #                 pass
    #                 n = n + 1
    #             print 'Хэрэглэгч дээрх ажилтны ID зөрсөн', n
    #             print 'Нийт ID шидсэн ажилтны тоо', i
    #             print 'Нийт ID шидээгүй ажилтны тоо', j
    #             print 'Нийт шалгасан ажилтны тоо', i+j+n
    #             
    #     
    #     return True
    #===========================================================================
        
