# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    
#
##############################################################################

import logging
import time
import datetime
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv, orm
from openerp.tools import float_is_zero
from openerp.tools.translate import _
from calendar import month, day_abbr, day_name
from dateutil import rrule
import math
from dateutil.relativedelta import relativedelta
from openerp.exceptions import except_orm
from openerp.exceptions import Warning
#import pymsgbox

class tbab_purchase_requisition_line(osv.osv):
    _inherit = 'purchase.requisition.line'
    
    _columns = {
        'note': fields.text('Note'),
        'partner_id':fields.many2one('res.partner','Partner'),
        'project_id':fields.many2one('project.project','Project'),
        'catalog_code': fields.char('Catalog code'),
        
    }
    
    
    def create(self, cr, uid, vals, context=None):
        purch_obj = self.pool.get('purchase.requisition')
        prod_obj = self.pool.get('product.product')
        if 'product_id' in vals:
            pr_id = prod_obj.search(cr, uid, [('id','=',vals['product_id'])])
            pr_pr = prod_obj.browse(cr, uid, pr_id)
            vals['product_uom_id'] = pr_pr.uom_id.id
        parent = purch_obj.search(cr,uid,[('id','=',vals['requisition_id'])])
        par = purch_obj.browse(cr,uid,parent)
        if par.project_id:
            vals['project_id'] = par.project_id.id
        employee_id = super(tbab_purchase_requisition_line, self).create(cr, uid, vals, context=context)
        return employee_id
    
    
    def write(self, cr, uid, ids, vals, context=None):
        obj = self.browse(cr, uid, ids)
        if 'product_id' in vals:
            vals['product_uom_id'] = obj.product_id.uom_id.id
        return super(tbab_purchase_requisition_line, self).write(cr, uid, ids, vals, context=context)


