# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from openerp.osv import osv,fields
import time

class res_company(osv.osv):
    _name = "res.company"
    _inherit = "res.company"
    _columns = {
                'income_currency_exchange_account_id': fields.many2one('account.account', 'Income Currency Rate Account', domain=[('type','=','other')], help='For the currency equalization, this account will be used to generate account entries when compute exchange difference'),
                'expense_currency_exchange_account_id': fields.many2one('account.account', 'Expense Currency Rate Account', domain=[('type','=','other')], help='For the currency equalization, this account will be used to generate account entries when compute exchange difference'),

                }



    
    
res_company()