# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from openerp.osv import osv
from openerp.report import report_sxw

# 
class sale_contract_end(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(sale_contract_end, self).__init__(cr, uid, name, context=context)
              
  
class report_sale_contract_end(osv.AbstractModel):
    _name = 'report.ierp_contract.sale_contract_end'
    _inherit = 'report.abstract_report'
    _template = 'ierp_contract.report_sale_contract_end'
    _wrapped_report_class = sale_contract_end
    
    
class ReportSaleContractEnd(osv.AbstractModel):
    _name = 'sale.contract.end'

    def render_html(self, cr, uid, ids, data=None, context=None):
        report_obj = self.pool['report']
        contract_obj = self.pool['account.analytic.account']
  
        report = report_obj._get_report_from_name(cr, uid, 'ierp_contract.sale_contract_end')
     
        selected_contract = contract_obj.browse(cr, uid, ids, context=context)
     
        ids_to_print = []
        for contract in selected_contract:
            print'lllllllllllllll',order.invoice_id
            if order.invoice_id:
                ids_to_print.append(order.id)
                
        docargs = {
            'doc_ids': ids_to_print,
            'doc_model': report.model,
            'docs': cdr,
        }
        return report_obj.render(cr, uid, ids, 'ierp_contract.sale_contract_end', docargs, context=context)
      

