# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2014 iERP Consulting (<http://www.ierp.mn>)
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

{
    "name" : "IERP - HR Payroll",
    "version" : "1.0",
    "description": """
        Хүний нөөцийн цалингийн модуль
    """,
    "depends" : [
        "hr",
        "hr_payroll",
        "account",
        'l10n_mn_base',
    ],
    "demo_xml" : [],
    "update_xml" : [
                    'security/payroll_security.xml',
                    'security/ir.model.access.csv',
                    'wizard/create_account_move.xml',
                    'wizard/advance_bank_report_view.xml',
                    'wizard/monthly_salary_report_view.xml',
                    'wizard/monthly_advance_report_view.xml',
                    'wizard/monthly_salary_bank.xml',
                    'wizard/payables_social_security.xml',
                    'wizard/payables_social_online_view.xml',
                    'wizard/sick_benefit_report_view.xml',
                    'wizard/payroll_recapitulation_view.xml',
                    'wizard/monthly_united_view.xml',
                    #'wizard/millionaire_general_view.xml',
                    'hr_hour_record_view.xml',
                    'hr_payroll_end_view.xml',
                    'hr_holidays_inherit_view.xml',
                    'hr_advance_salary_view.xml',
                    'hr_payroll_inherit.xml',
                    'menu_view.xml',
                ],
    "auto_install": False,
    "installable": True,
}