# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
import time
import exceptions
from datetime import date
from datetime import datetime

class loan_product(osv.osv):
	_name="loan.product"
	_description="Loan product"
	_columns={
			'name':fields.char('Name'),
	        'loan_product_type': fields.selection([
            			('loan_product','Loan product'),
                        ('interest_payment','Interest payment'),
                        ('accumulative_interest_payment','Accumlated interest payment'),
                        ('undue_loss','Surcharge payment'),
                        ('xxz_product','Past due loans'),
	        			('xb_product','Abnormal loans'),
	        			('ez_product','Doubted loans'),
	        			('mz_product','Bad loans'),],u'Loan product type', required=True),
            'period_type': fields.selection([
                        ('mounth',u'Month'),
                        ('day',u'Day'),], u'Period type', required=True),
			'min_period': fields.integer(u'Min period', required=True),
			'max_period': fields.integer(u'Max period', required=True),
			'min_amount': fields.integer(u'Min amount', required=True),
			'max_amount': fields.integer(u'Max amount', required=True),
			'min_interest': fields.float(u'Min interest', required=True),
			'max_interest': fields.float(u'Max interest', required=True),
			'currency': fields.many2one('res.currency',u'Currency'),
			'company_id':fields.many2one('res.company','Company'),
			'property_account_income': fields.property(
				type='many2one',
				relation='account.account',
				string="Income Account"),
			'property_account_expense': fields.property(
				type='many2one',
				relation='account.account',
				string="Expense Account"),
	}
	
	_defaults = {
		'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
        'period_type': lambda *a: 'mounth',
    }
    
	def onchange_account(self, cr, uid, ids,acc_id):
		val = {}
		war = {}
		if acc_id=='' or acc_id == False:
			return True
		if acc_id != False:
			acc = self.pool.get('account.account').browse(cr,uid,acc_id)
		
			if acc.currency_id.id == False:
				val['currency'] = acc.company_currency_id.id
			else:
				val['currency'] = acc.currency_id.id
		
			return {'value':val,'warning':war}
		
loan_product()
