# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
import time
import exceptions
from datetime import date
from datetime import datetime

class configure_loan_product(osv.osv):
	_name="configure.loan.product"
	_description="Settings of loan product"
	_columns={
			'company_id':fields.many2one('res.company','Company'),
			'name': fields.char(u'Name',size=256,required=True),
            'product_id': fields.many2one('loan.product','Loan product',domain=[('loan_product_type','=','loan_product')],required=True),
			'xt_product': fields.many2one('loan.product','Interest payment',domain=[('loan_product_type','=','interest_payment')],required=True),
			'xxt_product': fields.many2one('loan.product','Accumlated interest payment',domain=[('loan_product_type','=','accumulative_interest_payment')],required=True),
			'loss_product': fields.many2one('loan.product','Surcharge payment',domain=[('loan_product_type','=','undue_loss')],required=True),
			'xxz_product': fields.many2one('loan.product','Past due loans',domain=[('loan_product_type','=','xxz_product')],required=True),
			'xb_product': fields.many2one('loan.product','Abnormal loans',domain=[('loan_product_type','=','xb_product')],required=True),
			'ez_product': fields.many2one('loan.product','Doubted loans',domain=[('loan_product_type','=','ez_product')],required=True),
			'mz_product': fields.many2one('loan.product','Bad loans',domain=[('loan_product_type','=','mz_product')],required=True),

	}
	_defaults = {
				'company_id':lambda self, cr, uid, c: self.pool.get('res.users').browse(cr, uid, uid, c).company_id.id,
				}
configure_loan_product()
