# -*- encoding: utf-8 -*-
import time
from openerp.osv import osv, fields
import datetime
from dateutil import parser
from openerp.tools.translate import _

class closing_loan_report_wizard(osv.osv_memory):
	_name = 'closing.loan.report.wizard'
	_description = 'Closing Loan Report Wizard'
	
	_columns = {
		'note':fields.char(u'Тайлангийн нэр',size=64,readonly=True),
		'product':fields.many2one('loan.product',u'Зээлийн бүтээгдэхүүн',domain="[('loan_product_type','in',['loan_product'])]"),
	}

	_defaults = {
        'note': u'Хугацаа нь дуусаж буй гэрээний тайлан',
    }
	def print_report(self, cr, uid, ids, context=None):
		data = self.read(cr,uid,ids,[])[0]
		context['product'] = data['product']
		return {
            'type'         : 'ir.actions.report.xml',
            'context':context,
            'report_name'   : 'closing.loan',
            'datas': {
                    'model':'loan.order',
                    'id': context.get('active_ids') and context.get('active_ids')[0] or False,
                    'ids': context.get('active_ids') and context.get('active_ids') or [],
                    'report_type': 'pdf',
                    'form':data,
                },
            'nodestroy': False
        }
    	
closing_loan_report_wizard()
