# -*- coding: utf-8 -*-

import math
import re
import time

from openerp import SUPERUSER_ID
from openerp import tools
from openerp.osv import osv, fields, expression
#from openerp import models, fields, tools, api, exceptions, _
from openerp.tools.translate import _
from openerp.tools import DEFAULT_SERVER_DATETIME_FORMAT
from openerp.modules.module import get_module_resource
import psycopg2

from openerp.tools.safe_eval import safe_eval as eval
import openerp.addons.decimal_precision as dp
from openerp.tools.float_utils import float_round

    


class product_category_inherit(osv.osv):
    _inherit = "product.category"
    _description = "Product category inherit"
     
    _columns = {
                'category_code': fields.char('Category code'),
                }
    _sql_constraints = [
        ('category_code', 'unique (category_code)', u' Ангиллын код давхцаж болохгүй!')
    ]
     
    def onchange_parent_id(self, cr, uid, ids, parent_id, context=None):
        res = {}
        if parent_id != None:
            obj = self.pool.get('product.category')
            obj_id = obj.search(cr, uid, [('id','=',parent_id)])
            decr = obj.browse(cr, uid, obj_id)
            res['category_code']=decr.category_code
            return {'value':res}
     
    def create(self, cr, uid, data, context=None):
        par_code = ''
    #Getting 'Category code'
        #=======================================================================
        # if 'parent_id' in data:
        #     if data['parent_id']:
        #         obj = self.pool.get('product.category')
        #         obj_id = obj.search(cr, uid, [('id','=',data['parent_id'])])
        #         decr = obj.browse(cr, uid, obj_id)
        #         par_code = data['category_code'][0:len(decr.category_code)]
        #         if decr.category_code != par_code:
        #             raise osv.except_osv(_('Ангиллын кодын бүтцийн алдаа!'),_("Ангиллын кодын эхний хэсэг Эцэг ангиллын кодтой ижил байх ёстой"))
        #=======================================================================
        employee_id = super(product_category_inherit, self).create(cr, uid, data, context=context)
        #self.write(cr, uid, employee_id, {'employee_code': code})
        return employee_id
     
    def write(self, cr, uid, ids, vals, context=None):
        par_code = ''
    #Getting 'Category code'
        #=======================================================================
        # if 'parent_id' in vals:
        #     if vals['parent_id']:
        #         obj = self.pool.get('product.category')
        #         obj_id = obj.search(cr, uid, [('id','=',vals['parent_id'])])
        #         decr = obj.browse(cr, uid, obj_id)
        #         par_code = vals['category_code'][0:len(decr.category_code)]
        #         if decr.category_code != par_code:
        #             raise osv.except_osv(_('Ангиллын кодын бүтцийн алдаа!'),_("Ангиллын кодын эхний хэсэг Эцэг ангиллын кодтой ижил байх ёстой"))
        #=======================================================================
         
        return super(product_category_inherit, self).write(cr, uid, ids, vals, context=context)
    
     