# -*- coding: utf-8 -*-
##############################################################################
#    
#    Copyright (C) 2014 iERP Consulting (<http://www.ierp.mn>)
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

{
    "name" : "IERP - Sale",
    "version" : "1.0",
    "description": """    
        Монголын нөхцөлд нэмэлт хөгжүүлэлтийг хийв.
    """,
    "depends" : [
            "l10n_mn_base",
            "sale",
            "account",
            "crm",
            "project",
            "hr",
            "crm_claim",
            "crm_helpdesk",
            "account_analytic_analysis",
            "ierp_product_category",
            "product",
    ],
    "demo_xml" : [],
    "update_xml" : [
                    'sales_register_view.xml',
                    'res_partner_view.xml',
                    'crm_lead_view.xml',
                    'product_inherit_view.xml',
                    'sales_information_view.xml',
                    'choice_entry_view.xml',
                    'crm_phonecall_inherit_view.xml',
                    'sale_business_plan_view.xml',
                    'change_entry_view.xml',
                    'building_note_view.xml',
                    'building_building_view.xml',
                    'sale_view.xml',
                    'inherit_claim_view.xml',
                    'wizard/project_sale_plan_report_view.xml',
                    'wizard/lead_report_view.xml',
                    'wizard/choice_report_view.xml',
                    'wizard/payment_definition_view.xml',
                     
                    'wizard/project_performance_view.xml',
                    'wizard/building_info_view.xml',
                    'wizard/sale_detailed_plan_view.xml',
                    'wizard/sale_plan_detailed_performance_view.xml',
                    'wizard/cash_flow_detailed_plan_view.xml',
                    'wizard/cash_flow_sale_plan_view.xml',
                    'wizard/cash_flow_total_project_view.xml',
                    'wizard/cash_income_total_project_view.xml',
                    'wizard/contract_reg_report_view.xml',
                    'wizard/manager_sale_plan_view.xml',
                    'wizard/manager_income_plan_view.xml',
                    'wizard/inner_design_report_view.xml',
                    'menu_view.xml',
                    'security/sale_inherit_security.xml',
                    'security/ir.model.access.csv',
                    'default_values/ir.values.csv',
                ],
    "auto_install": False,
    "installable": True,
}