import openerp
from openerp.addons.crm import crm
from openerp.osv import fields, osv
from openerp import tools
from openerp.tools.translate import _
from openerp.tools import html2plaintext



class crm_claim(osv.osv):
    _inherit = "crm.claim"
    _description = "Claim"
   
    
    _columns = {
                'interpreter_company': fields.many2one('res.partner','Interpreter company'),
                'check_user_id':fields.many2one('hr.employee','Check engineer'),
                'project_id':fields.many2one('project.project','Project'),
                'claim_building_id':fields.many2one('building.building','Building'),
                'claim_door_id':fields.many2one('product.template','Door'),
                'experience':fields.text('Experience'),
                'sales_manager_id':fields.many2one('hr.employee', 'Sales manager', domain=[('department_id','=','Sales')]),
                'user_fault': fields.many2one('res.users','Trouble Responsible'),
                }