from datetime import datetime
from openerp.osv import osv
from openerp.osv import fields
from openerp.tools import translate
from openerp import netsvc
import time
import datetime
from datetime import date, timedelta
from lxml import etree
from operator import itemgetter
import openerp.addons.decimal_precision as dp

class res_partner(osv.osv):
    _inherit='res.partner'
    _columns = {
                'surename':fields.char('Surename', domain=[('customer','=',True)]),
                'lastname':fields.char('Lastname', domain=[('customer','=',True)]),
                'register_number':fields.char('Register', domain=[('customer','=',True)]),
                'age':fields.integer('Age', domain=[('customer','=',True)]),
                'family':fields.integer('Family', domain=[('customer','=',True)]),
                'line_business_id':fields.many2one('business.line','Business line'),
                'car_digit':fields.integer('Car digit', domain=[('customer','=',True)]),
                'car_type':fields.selection([
                                             ('automobile','Automobile'),
                                             ('jeep','Jeep'),
                                             ('automobile_jeep','Automobile and jeep')],'Car type', domain=[('customer','=',True)]),
                'emplacement':fields.char('Emplacement the main reason', domain=[('customer','=',True)]),
                'gender':fields.selection([('male','Male'),
                                           ('female','Female')],'Gender', domain=[('customer','=',True)]),
                'interpreter':fields.boolean('Interpreter', help="Check this box if this contact is a interpreter."),
               }
    _defaults = {
                'company_id': False,
                }

class business_line(osv.osv):
    _name='business.line'
    _columns = {
                'name':fields.char('Business line'),
                }