# -*- coding: utf-8 -*-

import time
from lxml import etree
from openerp.osv import fields, osv
from openerp.tools.translate import _
import datetime
import openerp.netsvc
import xlwt
from xlwt import Workbook, Formula
from dateutil.relativedelta import relativedelta

class manager_income_plan(osv.osv_memory):
    _inherit = "abstract.report.excel"
    _name = "manager.income.plan"
    _description = "Manager income plan"
    
    _columns = {
    }
    
    def get_export_data(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        form = self.browse(cr, uid, ids[0], context=context)
        user = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        datas = {'ids': context.get('active_ids', [])}
        datas['form'] = self.read(cr, uid, ids)[0]
        
        data = datas['form']
        
        ezxf = xlwt.easyxf
        styles = self.get_easyxf_styles()
        style1 = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_header = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table = ezxf('font: bold off; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        style_table_bold = ezxf('font: bold on; align: wrap on, vert centre, horiz center; borders: top thin, left thin, bottom thin, right thin;')
        stylebr = ezxf('font: bold off, name Times New Roman, height 160; borders: bottom thin, right thin, top thin, left thin; align: wrap on;')
        style_noborder = ezxf('font: bold on, name Times New Roman, height 200; align: wrap off;')
        stylebr1 = ezxf('font: bold off, name Times New Roman, height 200; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        style_nodatatable = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap off, vertical center, horizontal left;')
        stylebr2 = ezxf('font: bold off, name Times New Roman, height 120; borders: bottom thin, right thin, top thin, left thin; align: wrap on, vertical center, horizontal left;')
        book = xlwt.Workbook(encoding='utf8')
        sheet = book.add_sheet('Project sale plan')
        sheet.portrait = False
        
        
       
        sheet.write_merge(2, 2, 1, 4, u'Менежерийн мөнгөн орлогын төлөвлөгөө,гүйцэтгэл', ezxf('font: bold on;align:wrap off,vert centre;'))
        sheet.write_merge(3, 3, 6, 6, u'Огноо:',style_noborder)
        sheet.write_merge(5, 6, 0, 0, u'Огноо',stylebr1) 
        sheet.write_merge(5, 6, 1, 1, u'Үзүүлэлт',stylebr1)
        sheet.write_merge(7, 9, 0, 0, u'',stylebr1)
        sheet.write_merge(10, 12, 0, 0, u'',stylebr1)
        sheet.write_merge(13, 15, 0, 0, u'',stylebr1)
        sheet.write_merge(16, 18, 0, 0, u'',stylebr1)
        sheet.write_merge(19, 21, 0, 0, u'',stylebr1)
        sheet.write_merge(22, 24, 0, 0, u'',stylebr1)
        sheet.write_merge(25, 27, 0, 0, u'',stylebr1)
        sheet.write_merge(28, 30, 0, 0, u'',stylebr1)
        sheet.write_merge(31, 33, 0, 0, u'',stylebr1)
        sheet.write_merge(34, 36, 0, 0, u'',stylebr1)
        sheet.write_merge(37, 39, 0, 0, u'',stylebr1)
        sheet.write_merge(40, 42, 0, 0, u'',stylebr1)
        sheet.write_merge(7, 7, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(8, 8, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(9, 9, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(10, 10, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(11, 11, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(12, 12, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(13, 13, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(14, 14, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(15, 15, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(16, 16, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(17, 17, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(18, 18, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(19, 19, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(20, 20, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(21, 21, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(22, 22, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(23, 23, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(24, 24, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(25, 25, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(26, 26, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(27, 27, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(28, 28, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(29, 29, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(30, 30, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(31, 31, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(32, 32, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(33, 33, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(34, 34, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(35, 35, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(36, 36, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(37,37, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(38, 38, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(39, 39, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(40, 40, 1, 1, u'Гэрээний борлуулалтын төлөвлөгөө',stylebr1)
        sheet.write_merge(41, 41, 1, 1, u'Байгуулсан гэрээний дүн',stylebr1)
        sheet.write_merge(42, 42, 1, 1, u'Биелэлтийн хувь',stylebr1)
        sheet.write_merge(5, 5, 2, 2, u'',stylebr1)
        sheet.write_merge(5, 5, 3, 3, u'',stylebr1)
        sheet.write_merge(5, 5, 4, 4, u'',stylebr1)
        sheet.write_merge(5, 5, 5, 5, u'',stylebr1)
        sheet.write_merge(5, 5, 6, 6, u'',stylebr1)
        sheet.write_merge(5, 5, 7, 7, u'',stylebr1)
        sheet.write_merge(6, 6, 2, 2, u'1',stylebr1)
        sheet.write_merge(6, 6, 3, 3, u'2',stylebr1)
        sheet.write_merge(6, 6, 4, 4, u'3',stylebr1)
        sheet.write_merge(6, 6, 5, 5, u'4',stylebr1)
        sheet.write_merge(6, 6, 6, 6, u'5',stylebr1)
        sheet.write_merge(6, 6, 7, 7, u'6',stylebr1)
      
       
         
      
        inch = 1100
        sheet.col(0).width = 3*inch
        sheet.col(1).width = 8*inch
        sheet.col(2).width = 3*inch #shirheg
        sheet.col(3).width = 3*inch
        sheet.col(4).width = 3*inch
        sheet.col(5).width = 3*inch
        sheet.col(6).width = 3*inch
        sheet.col(7).width = 3*inch
        sheet.col(8).width = 3*inch
       
     
        return {'data':book}

manager_income_plan()