# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2014-2020 ShineERP Co.,ltd (<http://www.serp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, 205, ShineERP LLC
#    Email : info@serp.mn
#    Phone : 976 + 88001963
#
##############################################################################

{
    "name" : "Mongolian Account Charts",
    "version" : "1.0",
    "author" : "ShineERP Development Team",
    "category" : "Localization/Account Charts",
    "description": """
This is the module to manage the accounting chart for Mongolia in OpenERP.
Mongolian accounting chart and localization.
    """,
    
    "depends" : ['base_vat','account_chart','account','l10n_mn_base'],
    "demo_xml" : [],
    "update_xml" : [
                    'account_chart_small.xml',
                    'account_chart_small_custom.xml',
                    'account_chart_ncd.xml',
                    'account_chart_ncd_custom.xml',
                    'account_tax.xml',
                    ],
    "auto_install": False,
    "installable": True,
    "icon": '/l10n_mn/static/src/img/shineerp.png',
}