# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

{
    "name" : "l10n_mn - Accounting Reports",
    "version" : "1.0",
    "author" : "ShineERP",
    "category" : "Generic Modules/Account",
    "description": """
The accounting reports for mongolian law.
    *Depending l10n_mn, l10n_mn_base modules.
    """,
    "depends" : ["ierp_account"],
    "demo_xml" : [],
    "update_xml" : [
                    "wizard/account_balance_report_view.xml",
                    "wizard/account_profit_report_view.xml",
                    "account_report_configure_view.xml",
                    "account_cashflow_report_configure_view.xml",
                    "account_prepayment_configure_view.xml",
                    "wizard/currency_balance_view.xml",
                    "wizard/account_cashflow_statement_report_view.xml",
                    "wizard/account_invoice_sheet_report_view.xml",
                    "wizard/account_detail_register_view.xml",
                    "wizard/account_prepayment_view.xml",
                    "wizard/account_property_report_view.xml",
                    "data/balance_report_data.xml",
                    "account_stockholders_equity_report_config_view.xml",
                   # "data/account_stockholders_equity_report_data.xml",
                    "wizard/account_stockholders_equity_report_view.xml",
                    #"payment_order_report.xml",
                    "report_menu.xml",
    ],
    "auto_install": False,
    "installable": True,
}