# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2014 ShineERP Co.,ltd (<http://www.serp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################
from openerp.osv import osv, fields, orm
from openerp.tools.translate import _
import time
import openerp.addons.decimal_precision as dp
import logging
from datetime import datetime
from dateutil.relativedelta import relativedelta
from operator import itemgetter
import time
from openerp import SUPERUSER_ID
from openerp import pooler, tools
from openerp.osv import fields, osv
from openerp.tools.translate import _
from openerp.tools.float_utils import float_round

class account_account(osv.osv):
    _inherit = 'account.account'
    _description = "Account report configure"
    
    _columns = {
                'account_ids':fields.many2one('account.config','account_id','Account'),
                }

class account_report_configure(osv.osv):
    _name = 'account.report.configure'
    _description = "Account report configure"
    
    _columns = {
                'company_id':fields.many2one('res.company','Company'),
                'name':fields.selection([('balance',u'Санхүүгийн байдлын тайлан'),
                                         ('income',u'Орлогын тайлан')],'Report name'),
                'report_id':fields.one2many('account.config','report_id'),
                }
    _defaults = {
              'company_id': lambda obj,cr,uid,c=None:obj.pool.get('res.company')._company_default_get(cr,uid,'account.balance.sheet',context=c),

              }
class account_config(osv.osv):
    _name = 'account.config'
    
    _columns = {
                'sequence':fields.char('Sequence',required=True),
                'name':fields.char('Name',required=True),
                'type':fields.selection([('current_asset','Current asset'),
                                         ('noncurrent_asset','Non current asset'),
                                         ('short_term_liability','Short term liability'),
                                         ('long_term_liability','Long term liability'),
                                         ('owner_property','Owner property'),
                                         ('sale_income','Sale income'),
                                         ('sale_cost','Sale cost'),
                                         ('income','Income'),
                                         ('tax_cost','Income tax cost'),
                                         ('other_income','Other income'),
                                         ('cost','Cost')],'Account report type',required=True),
                'account_id':fields.many2many('account.account','account_config_rel','account_id','aid','Account'),
                'report_id':fields.many2one('account.report.configure'),
                
                }