# -*- coding: utf-8 -*-
##############################################################################
#
#    ShineERP, Enterprise Management Solution    
#    Copyright (C) 2007-2012 ShineERP Co.,ltd (<http://www.erp.mn>). All Rights Reserved
#
#    Address : Suhkbaatar District, National ITPark, ShineERP LLC
#    Email : info@erp.mn
#    Phone : 976 + 11-318043
#
##############################################################################

from c2c_reporting_tools.reports.standard_report import *
from c2c_reporting_tools.flowables.simple_row_table import *
from c2c_reporting_tools.c2c_helper import *
from c2c_reporting_tools.translation import _
from reportlab.platypus import *
from reportlab.lib.colors import red, black, navy, white, green
from reportlab.lib.enums import TA_LEFT, TA_RIGHT, TA_CENTER, TA_JUSTIFY

from datetime import datetime
from dateutil.relativedelta import relativedelta
from operator import itemgetter
import time
from xlwt import Workbook, Formula
class payment_order_report(osv.osv):
    _inherit = "account.bank.statement.line"
    
    def get_export_print(self, cr, uid, ids, context=None):
        obj = self.browse(cr, uid, ids[0])
        bank = self.pool.get('res.partner.bank')
        res = self.pool.get('res.partner')
        line_id = self.pool.get('account.bank.statement.line').browse(cr, uid,obj.id)
        statement = self.pool.get('account.bank.statement').browse(cr, uid,line_id.statement_id.id)
        bank_ids = bank.search(cr, uid, [('journal_id','=',statement.journal_id.id)])
        if bank_ids:
            com_bnk = bank.browse(cr, uid, bank_ids)[0]
            context['com_bank_name'] = com_bnk.bank_name
            context['com_account_number'] = com_bnk.acc_number
            context['com_partner'] = com_bnk.partner_id.name
            context['com_bnk_code'] = com_bnk.bank_bic
        if line_id.partner_id:
            bank_id = bank.search(cr, uid, [('partner_id','=',line_id.partner_id.id)])
            if bank_id:
                bnk = bank.browse(cr, uid, bank_id)[0]
                context['bank_name'] = bnk.bank_name
                context['account_number'] = bnk.acc_number
                context['partner'] = bnk.partner_id.name
                context['bnk_code'] = bnk.bank_bic
        context['amount'] = line_id.amount
        context['name'] = line_id.name
        context['date'] = statement.date
        context['company'] = statement.company_id.name
                
 
        return {
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'payment.order.reportsd',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context,
            'nodestroy': True,
        }


payment_order_report()

    
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: