# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    
#
##############################################################################

import logging
import time
import datetime
from datetime import date, timedelta, datetime
from openerp import SUPERUSER_ID
from openerp import tools
from openerp.modules.module import get_module_resource
from openerp.osv import fields, osv
from openerp import models, fields, api, _
from openerp.tools import float_is_zero
from openerp.tools.translate import _
from calendar import month, day_abbr, day_name
from dateutil import rrule
import math
from dateutil.relativedelta import relativedelta

class tbab_duplicate_assets(osv.osv):
    _name = 'tbab.duplicate.assets'
    _description = 'Tbab duplicate assets'
    #_order = 'sequence'
    
    _columns = {
                
    }
    
    # Assets
    def duplicate_assets(self, cr, uid, ids, context=None):
        
        i = 0
        float_qty = 0.0
        acc_asset_obj = self.pool.get('account.asset.asset')
        account_asset_ids = acc_asset_obj.search(cr, uid, [('type','=','asset')])
        for acc_asset_id in account_asset_ids:
            acc_asset = acc_asset_obj.browse(cr,uid,acc_asset_id)
            float_qty = acc_asset.asset_qty - int(acc_asset.asset_qty)
            if acc_asset.asset_qty == 0.0:
                i = 0
            elif float_qty != 0.0:
                i = int(acc_asset.asset_qty) + 1
            else:
                i = int(acc_asset.asset_qty)
            i = i - 1
            while i > 0:
                self.pool.get('account.asset.asset').copy(cr,uid,acc_asset.id,context=None)
                i = i - 1
                if i == 0:
                    break
        return True
    # Consumables
    def duplicate_consumables(self, cr, uid, ids, context=None):
        
        i = 0
        float_qty = 0.0
        acc_asset_obj = self.pool.get('account.asset.asset')
        account_asset_ids = acc_asset_obj.search(cr, uid, [('type','=','consumable')])
        for acc_asset_id in account_asset_ids:
            acc_asset = acc_asset_obj.browse(cr,uid,acc_asset_id)
            float_qty = acc_asset.asset_qty - int(acc_asset.asset_qty)
            if acc_asset.asset_qty == 0.0:
                i = 0
            elif float_qty != 0.0:
                i = int(acc_asset.asset_qty) + 1
            else:
                i = int(acc_asset.asset_qty)
            i = i - 1
            while i > 0:
                self.pool.get('account.asset.asset').copy(cr,uid,acc_asset.id,context=None)
                i = i - 1
                if i == 0:
                    break
        return True
    
    def change_assets_qty_to_1(self, cr, uid, ids, context=None):
        
        i = 0
        float_qty = 0.0
        acc_asset_obj = self.pool.get('account.asset.asset')
        account_asset_ids = acc_asset_obj.search(cr, uid, [('type','=','asset')])
        print 'aaaaaaaaaaa', account_asset_ids
        for acc_asset_id in account_asset_ids:
            acc_asset_obj.write(cr, uid, acc_asset_id, {'asset_qty':1})
        return True
    
    def change_consumables_qty_to_1(self, cr, uid, ids, context=None):
        
        i = 0
        float_qty = 0.0
        acc_asset_obj = self.pool.get('account.asset.asset')
        account_asset_ids = acc_asset_obj.search(cr, uid, [('type','=','consumable')])
        print 'aaaaaaaaaaa', account_asset_ids
        for acc_asset_id in account_asset_ids:
            acc_asset_obj.write(cr, uid, acc_asset_id, {'asset_qty':1})
        return True
